Package net.sf.saxon.dom

## Class DOMObjectModel

- java.lang.Object
- - net.sf.saxon.om.TreeModel
  - - net.sf.saxon.dom.DOMObjectModel

- All Implemented Interfaces:
    `ExternalObjectModel`

      public class DOMObjectModel
      extends TreeModel
      implements ExternalObjectModel

  This interface must be implemented by any third-party object model that can be wrapped with a wrapper that implements the Saxon Object Model (the NodeInfo interface). This implementation of the interface supports wrapping of DOM Documents.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.om.TreeModel

      `LINKED_TREE, TINY_TREE, TINY_TREE_CONDENSED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DOMObjectModel()` | Create an instance of the DOMObjectModel class.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static java.lang.Object` | `convertXPathValueToObject​(Sequence value, java.lang.Class<?> target)` | Convert an XPath value to an object in this object model.
    `NodeInfo` | `copy​(org.w3c.dom.Node node, TreeModel model, Configuration config)` | Copy a DOM node to create a node in a different tree model
    `Receiver` | `getDocumentBuilder​(javax.xml.transform.Result result)` | Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events.
    `java.lang.String` | `getDocumentClassName()` | Get the name of a characteristic class, which, if it can be loaded, indicates that the supporting libraries for this object model implementation are available on the classpath
    `java.lang.String` | `getIdentifyingURI()` | Get the URI of the external object model as used in the JAXP factory interfaces for obtaining an XPath implementation
    `static DOMObjectModel` | `getInstance()` | Get a reusable instance of this class.
    `JPConverter` | `getJPConverter​(java.lang.Class sourceClass, Configuration config)` | Get a converter from values in the external object model to XPath values.
    `java.lang.String` | `getName()` | Get a name that identifies the tree model
    `PJConverter` | `getNodeListCreator​(java.lang.Object node)` | Get a converter that converts a sequence of XPath nodes to this model's representation of a node list.
    `PJConverter` | `getPJConverter​(java.lang.Class<?> targetClass)` | Get a converter from XPath values to values in the external object model
    `Builder` | `makeBuilder​(PipelineConfiguration pipe)` | Make a Builder, which can then be used to construct an instance of this tree model from a stream of events
    `static void` | `sendDOMSource​(javax.xml.transform.dom.DOMSource source, Receiver receiver)` |
    `boolean` | `sendSource​(javax.xml.transform.Source source, Receiver receiver)` | Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true.
    `NodeInfo` | `unravel​(javax.xml.transform.Source source, Configuration config)` | Wrap or unwrap a node using this object model to return the corresponding Saxon node.
    `NodeInfo` | `wrap​(org.w3c.dom.Node node, Configuration config)` | Wrap a DOM node using this object model to return the corresponding Saxon node.

    - ### Methods inherited from class net.sf.saxon.om.TreeModel

      `getSymbolicValue, getTreeModel, isMutable, isSchemaAware`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DOMObjectModel

          public DOMObjectModel()

      Create an instance of the DOMObjectModel class.

      When possible, use the getInstance() method in preference, as the instance is then reusable.

  - ### Method Detail

    - #### getInstance

          public static DOMObjectModel getInstance()

      Get a reusable instance of this class.

      Note, this is not actually a singleton instance; the class also has a public constructor, which is needed to support the automatic loading of object models into the Configuration.

      Returns:
        the singleton instance

    - #### getDocumentClassName

          public java.lang.String getDocumentClassName()

      Get the name of a characteristic class, which, if it can be loaded, indicates that the supporting libraries for this object model implementation are available on the classpath
      Specified by:
        `getDocumentClassName` in interface `ExternalObjectModel`
      Returns:
        by convention (but not necessarily) the class that implements a document node in the relevant external model

    - #### getIdentifyingURI

          public java.lang.String getIdentifyingURI()

      Get the URI of the external object model as used in the JAXP factory interfaces for obtaining an XPath implementation
      Specified by:
        `getIdentifyingURI` in interface `ExternalObjectModel`
      Returns:
        the URI used to identify this object model in the JAXP XPath factory mechanism.

    - #### getName

          public java.lang.String getName()

      Description copied from class: `TreeModel`
      Get a name that identifies the tree model
      Overrides:
        `getName` in class `TreeModel`
      Returns:
        an identifying name for the tree model

    - #### getPJConverter

          public PJConverter getPJConverter​(java.lang.Class<?> targetClass)

      Get a converter from XPath values to values in the external object model
      Specified by:
        `getPJConverter` in interface `ExternalObjectModel`
      Parameters:
        `targetClass` - the required class of the result of the conversion. If this class represents a node or list of nodes in the external object model, the method should return a converter that takes a native node or sequence of nodes as input and returns a node or sequence of nodes in the external object model representation. Otherwise, it should return null.
      Returns:
        a converter, if the targetClass is recognized as belonging to this object model; otherwise null

    - #### getJPConverter

          public JPConverter getJPConverter​(java.lang.Class sourceClass,
                                            Configuration config)

      Description copied from interface: `ExternalObjectModel`
      Get a converter from values in the external object model to XPath values.
      Specified by:
        `getJPConverter` in interface `ExternalObjectModel`
      Parameters:
        `sourceClass` - the class (static or dynamic) of values to be converted
        `config` - the Saxon Configuration object
      Returns:
        a converter, if the sourceClass is recognized as belonging to this object model; otherwise null

    - #### getNodeListCreator

          public PJConverter getNodeListCreator​(java.lang.Object node)

      Get a converter that converts a sequence of XPath nodes to this model's representation of a node list.
      Specified by:
        `getNodeListCreator` in interface `ExternalObjectModel`
      Parameters:
        `node` - an example of the kind of node used in this model
      Returns:
        if the model does not recognize this node as one of its own, return null. Otherwise return a PJConverter that takes a list of XPath nodes (represented as NodeInfo objects) and returns a collection of nodes in this object model

    - #### getDocumentBuilder

          public Receiver getDocumentBuilder​(javax.xml.transform.Result result)
                                      throws XPathException

      Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events. If the Result is not recognised, or is not a `DOMResult`, return null.
      Specified by:
        `getDocumentBuilder` in interface `ExternalObjectModel`
      Parameters:
        `result` - a JAXP result object
      Returns:
        either a Receiver that can be used to build a DOM instance, or null
      Throws:
        `XPathException` - if any failure occurs

    - #### makeBuilder

          public Builder makeBuilder​(PipelineConfiguration pipe)

      Description copied from class: `TreeModel`
      Make a Builder, which can then be used to construct an instance of this tree model from a stream of events
      Specified by:
        `makeBuilder` in class `TreeModel`
      Parameters:
        `pipe` - A PipelineConfiguration, which can be constructed using the method `Configuration.makePipelineConfiguration()`.
      Returns:
        a newly created Builder

    - #### sendSource

          public boolean sendSource​(javax.xml.transform.Source source,
                                    Receiver receiver)
                             throws XPathException

      Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true. Otherwise, return false
      Specified by:
        `sendSource` in interface `ExternalObjectModel`
      Parameters:
        `source` - a JAXP Source object
        `receiver` - the Receiver that is to receive the data from the Source. The caller is responsible for opening and closing the receiver.
      Returns:
        true if the data from the Source has been sent to the Receiver, false otherwise
      Throws:
        `XPathException` - if any failure occurs

    - #### sendDOMSource

          public static void sendDOMSource​(javax.xml.transform.dom.DOMSource source,
                                           Receiver receiver)
                                    throws XPathException

      Throws:
        `XPathException`

    - #### wrap

          public NodeInfo wrap​(org.w3c.dom.Node node,
                               Configuration config)

      Wrap a DOM node using this object model to return the corresponding Saxon node.
      Parameters:
        `node` - the DOM node to be wrapped
        `config` - the Saxon Configuration
      Returns:
        the wrapped DOM node
      Since:
        9.2

    - #### copy

          public NodeInfo copy​(org.w3c.dom.Node node,
                               TreeModel model,
                               Configuration config)
                        throws XPathException

      Copy a DOM node to create a node in a different tree model
      Parameters:
        `node` - the DOM node to be copied
        `model` - the target tree model
        `config` - the Saxon Configuration
      Returns:
        the copied node
      Throws:
        `XPathException` - if the operation fails
      Since:
        9.2

    - #### unravel

          public NodeInfo unravel​(javax.xml.transform.Source source,
                                  Configuration config)

      Wrap or unwrap a node using this object model to return the corresponding Saxon node. If the supplied source does not belong to this object model, return null
      Specified by:
        `unravel` in interface `ExternalObjectModel`
      Parameters:
        `source` - a JAXP Source object
        `config` - the Saxon configuration
      Returns:
        a NodeInfo corresponding to the Source, if this can be constructed; otherwise null

    - #### convertXPathValueToObject

          public static java.lang.Object convertXPathValueToObject​(Sequence value,
                                                                   java.lang.Class<?> target)
                                                            throws XPathException

      Convert an XPath value to an object in this object model. If the supplied value can be converted to an object in this model, of the specified class, then the conversion should be done and the resulting object returned. If the value cannot be converted, the method should return null. Note that the supplied class might be a List, in which case the method should inspect the contents of the Value to see whether they belong to this object model.
      Parameters:
        `value` - the XPath value to be converted
        `target` - the class of object required
      Returns:
        the result of the conversion
      Throws:
        `XPathException` - if the target class is explicitly associated with this object model, but the supplied value cannot be converted to the appropriate class